diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
index 686f1850ca..1dcf6abd42 100644
--- a/src/backend/commands/tablecmds.c
+++ b/src/backend/commands/tablecmds.c
@@ -8987,7 +8987,10 @@ ATExecSetStatistics(Relation rel, const char *colName, int16 colNum, Node *newVa
 	if (!newtarget_default)
 		repl_val[Anum_pg_attribute_attstattarget - 1] = newtarget;
 	else
+	{
+		repl_val[Anum_pg_attribute_attstattarget - 1] = (Datum) 0;
 		repl_null[Anum_pg_attribute_attstattarget - 1] = true;
+	}
 	repl_repl[Anum_pg_attribute_attstattarget - 1] = true;
 	newtuple = heap_modify_tuple(tuple, RelationGetDescr(attrelation),
 								 repl_val, repl_null, repl_repl);
@@ -9061,7 +9064,10 @@ ATExecSetOptions(Relation rel, const char *colName, Node *options,
 	if (newOptions != (Datum) 0)
 		repl_val[Anum_pg_attribute_attoptions - 1] = newOptions;
 	else
+	{
+		repl_val[Anum_pg_attribute_attoptions - 1] = (Datum) 0;
 		repl_null[Anum_pg_attribute_attoptions - 1] = true;
+	}
 	repl_repl[Anum_pg_attribute_attoptions - 1] = true;
 	newtuple = heap_modify_tuple(tuple, RelationGetDescr(attrelation),
 								 repl_val, repl_null, repl_repl);
